import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLCapabilities;
import javax.swing.JFrame;

import com.sun.opengl.util.FPSAnimator;

/**
 * Initialization class for displaying a jelly fish made of basic 2D geometric shapes.
 * @author Damian Johnson
 * @version October 3 2007
 */
public class Starter {
  private static final Dimension INITIAL_DISPLAY_SIZE = new Dimension(500, 500);
  
  public static void main(String[] args) {
    JFrame frame = new JFrame();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setTitle("Mr. Jelly");
    
    GLCapabilities caps = new GLCapabilities();
    caps.setDoubleBuffered(true); // Enables double buffering
    caps.setHardwareAccelerated(true);
    
    GLCanvas panel = new GLCanvas(caps);
    // GLJPanel panel = new GLJPanel(caps); // Swing variant lacks hardware acceleration
    panel.addGLEventListener(new MrJellyRenderer());
    panel.setPreferredSize(INITIAL_DISPLAY_SIZE);
    
    final FPSAnimator animator = new FPSAnimator(panel, 30);
    animator.setRunAsFastAsPossible(false); // Restricts rate that display is called
    
    frame.addWindowListener(new WindowAdapter() {
      // Stops animator when closing
      public void windowClosing(WindowEvent e) {
        new Thread(new Runnable() {
          public void run() {
            animator.stop();
            System.exit(0);
          }
        }).start();
      }
    });
    animator.start();
    
    frame.add(panel);
    frame.pack();
    frame.setVisible(true);
  }
}
